PrimeBuilder.Elements = [
	{
		title: 'Global Settings',
		type: 'page',
		icon: 'far fa-file-alt',
		options: [
			{
				name: 'general',
				target: 'body',
			},
			{
				name: 'pagetypo',
				target: 'body'	
			},
			{
				name: 'background',
				target: 'body'	
			},
			{
				name: 'popup',
				target: 'body'	
			},
			{
				name: 'infobar',
				target: 'body'	
			},
			{
				name: 'slider',
				target: 'body'
			},
			{
				name: 'rightclick',
				target: 'body'	
			},
			{
				name: 'gateway',
				target: 'body'	
			},
			{
				name: 'scripts',
				target: 'body'	
			},
			{
				name: 'pageadvanced',
				target: 'body'	
			},
		]
	},
	{
		title: 'Section',
		type: 'section',
		icon: 'far fa-square',
		classes: 'ib2-section-el',
		positioning: false,
		resizable: [],
		targetWidth: ["outer"],
		targetHeight: ["content"],
		useMinHeight: true,
		category: 'element',
		sortable: true,
		options: [
			{
				name: 'sectionsize',
				target: 'outer',
				condition: 'normal-only'
			},
			{
				name: 'popsetup',
				target: 'outer',
				condition: 'popup-only'
			},
			{
				name: 'anchor',
				target: 'outer'	
			},
			{
				name: 'minheight',
				target: 'content'	
			},
			{
				name: 'background',
				target: 'middle'	
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'middle'
			},
			{
				name: 'border',
				target: 'middle'
			},
			{
				name: 'corner',
				target: 'middle'
			},
			{
				name: 'separator',
				target: 'middle'
			},
			{
				name: 'boxshadow',
				target: 'middle'	
			},
			{
				name: 'opacity',
				target: 'middle'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Section',
		type: 'wsection',
		classes: 'ib2-wsection-el',
		icon: 'far fa-square',
		positioning: false,
		resizable: [],
		targetWidth: ["inner"],
		targetHeight: ["content"],
		useMinHeight: true,
		category: 'element',
		sortable: true,
		options: [
			{
				name: 'sectionsize',
				target: 'outer',
				condition: 'container only'
			},
			{
				name: 'anchor',
				target: 'outer'	
			},
			{
				name: 'background',
				target: 'middle'	
			},
			{
				name: 'minheight',
				target: 'content'	
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'middle'
			},
			{
				name: 'border',
				target: 'middle'
			},
			{
				name: 'corner',
				target: 'middle'
			},
			{
				name: 'separator',
				target: 'middle'
			},
			{
				name: 'boxshadow',
				target: 'middle'	
			},
			{
				name: 'opacity',
				target: 'middle'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	
	{
		title: 'Columns',
		type: 'columns',
		icon: 'fas fa-columns',
		classes: 'ib2-section-el',
		positioning: false,
		resizable: [],
		targetWidth: ["outer"],
		targetHeight: ["content"],
		useMinHeight: true,
		category: 'element',
		sortable: true,
		buttons: [
			{
				pos: 'first',
				id: 'add-column', 
				icon: 'far fa-plus-square', 
				title: 'Add Column', 
				action: 'addcolumn',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'add-column',
				id: 'remove-column', 
				icon: 'far fa-minus-square', 
				title: 'Remove Column', 
				action: 'removecolumn',
				classes: ''
			}
		],
		options: [
			{
				name: 'anchor',
				target: 'outer'	
			},
			{
				name: 'minheight',
				target: 'content'	
			},
			{
				name: 'background',
				target: 'middle'	
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'middle'
			},
			{
				name: 'colpadding',
				target: 'content',
				title: 'Column Padding'
			},
			{
				name: 'border',
				target: 'middle'
			},
			{
				name: 'corner',
				target: 'middle'
			},
			{
				name: 'boxshadow',
				target: 'middle'	
			},
			{
				name: 'opacity',
				target: 'middle'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Background Box',
		type: 'wbox',
		icon: 'dashicons dashicons-admin-page',
		classes: 'ib2-section-el',
		positioning: false,
		resizable: false,
		targetWidth: ["outer"],
		targetHeight: ["middle"],
		useMinHeight: true,
		category: 'element',
		sortable: true,
		options: [
			{
				name: 'height',
				target: 'outer'	
			},
			{
				name: 'background',
				target: 'middle'	
			},
			{
				name: 'border',
				target: 'middle'
			},
			{
				name: 'corner',
				target: 'middle'
			},
			{
				name: 'separator',
				target: 'middle'
			},
			{
				name: 'boxshadow',
				target: 'middle'	
			},
			{
				name: 'opacity',
				target: 'middle'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Heading',
		type: 'text',
		alias: 'title',
		icon: 'fas fa-heading',
		classes: 'ib2-text-el ib2-title-el',
		positioning: false,
		resizable: false,
		category: 'element',
		buttons: [
			{
				pos: 'first',
				id: 'text', 
				icon: 'fa fa-pencil', 
				title: 'Edit Title', 
				action: 'wysiwyg',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'text',
				id: 'legal-content', 
				icon: 'fas fa-file-contract', 
				title: 'Generate Legal Content', 
				action: 'legal',
				classes: '',
				actionclass: 'el-fbtn-action',
			},
		],
		options: [
			{
				name: 'typography',
				target: 'outer',
			},
			{
				name: 'textshadow',
				target: 'outer',
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Text',
		type: 'text',
		icon: 'fa fa-paragraph',
		classes: 'ib2-text-el',
		positioning: false,
		resizable: false,
		category: 'element',
		buttons: [
			{
				pos: 'first',
				id: 'text', 
				icon: 'fa fa-pencil', 
				title: 'Edit Text', 
				action: 'wysiwyg',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'text',
				id: 'legal-content', 
				icon: 'fas fa-file-contract', 
				title: 'Generate Legal Content', 
				action: 'legal',
				classes: '',
				actionclass: 'el-fbtn-action',
			},
		],
		options: [
			{
				name: 'typography',
				target: 'outer',
			},
			{
				name: 'textshadow',
				target: 'outer',
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Image',
		type: 'image',
		icon: 'fa fa-image',
		classes: 'ib2-image-el',
		positioning: true,
		resizable: ["s", "e", "n", "w"],
		targetWidth: ["image", "middle"],
		targetHeight: ["middle"],
		targetMargin: ["image"],
		category: 'element',
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'image',
				target: 'image'	
			},
			{
				name: 'imagestyle',
				target: 'image'	
			},
			{
				name: 'imagefilter',
				target: 'image'	
			},
			{
				name: 'imagecaption',
				target: 'figure'	
			},
			{
				name: 'buttonaction',
				target: 'link'
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'middle'	
			},
			{
				name: 'opacity',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Video',
		type: 'video',
		icon: 'fa fa-video',
		classes: 'ib2-video-container',
		positioning: true,
		resizable: ["e"],
		targetWidth: ["outer"],
		category: 'element',
		options: [
			{
				name: 'video',
				target: 'middle',
			},
			{
				name: 'padding',
				target: 'outer'	
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'backgroundcolor',
				target: 'outer'	
			},
			{
				name: 'opacity',
				target: 'outer'
			},
			{
				name: 'border',
				target: 'outer'
			},
			{
				name: 'corner',
				target: 'outer'
			},
			{
				name: 'boxshadow',
				target: 'outer'	
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Button',
		type: 'button',
		icon: 'fas fa-hand-point-up',
		classes: 'ib2-button-el',
		positioning: true,
		resizable: ['e'],
		targetWidth: ["middle", "button"],
		targetHeight: ["middle", "button"],
		useMinHeight: true,
		useMinWidth: false,
		category: 'element',
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'buttontext',
				target: 'button'
			},
			{
				name: 'buttonstyle',
				target: 'button'
			},
			{
				name: 'buttoncolor',
				target: 'button'
			},
			{
				name: 'border',
				target: 'button'
			},
			{
				name: 'buttonicon',
				target: 'icon'
			},
			{
				name: 'corner',
				target: 'button'
			},
			{
				name: 'buttonaction',
				target: 'button'
			},
			{
				name: 'padding',
				target: 'button'
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'effect',
				target: 'outer'
			}
		],
	},
	{
		title: 'Box',
		type: 'box',
		icon: 'fas fa-box',
		classes: 'ib2-box-el',
		positioning: true,
		resizable: ['s', 'e'],
		targetWidth: ["middle", "box"],
		targetHeight: ["middle", "box", "boxcontent"],
		useMinHeight: true,
		category: 'element',
		sortable: true,
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'anchor',
				target: 'outer'	
			},
			{
				name: 'boxsize',
				target: 'box'
			},
			{
				name: 'background',
				target: 'box'	
			},
			{
				name: 'margin',
				target: 'outer'	
			},
			{
				name: 'padding',
				target: 'box'
			},
			{
				name: 'border',
				target: 'box'
			},
			{
				name: 'corner',
				target: 'box'
			},
			{
				name: 'opacity',
				target: 'box'
			},
			{
				name: 'boxshadow',
				target: 'box'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Spacer',
		type: 'spacer',
		icon: 'dashicons dashicons-editor-insertmore',
		classes: '',
		positioning: false,
		resizable: ['s'],
		targetHeight: ["outer", "middle"],
		category: 'element',
		options: []
	},
	{
		title: 'Horizontal Line',
		type: 'hline',
		icon: 'dashicons dashicons-minus',
		classes: '',
		positioning: false,
		resizable: ['e'],
		targetWidth: ["middle", "line"],
		targetHeight: ["line"],
		category: 'element',
		options: [
			{
				name: 'line',
				target: 'line'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Opt-In Form',
		type: 'form',
		icon: 'fas fa-envelope',
		classes: '',
		positioning: true,
		resizable: ['e'],
		category: 'element',
		targetWidth: ["middle"],
		targetHeight: ["middle"],
		useMinHeight: false,
		useMinWidth: false,
		buttons: [
			{
				pos: 'first',
				id: 'form-popup', 
				icon: 'far fa-id-card', 
				title: 'Edit Fields', 
				action: 'manageform',
				classes: ''
			},
		],
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'formdata',
				target: 'form'
			},
			{
				name: 'webinar',
				target: 'form'
			},
			{
				name: 'formredirect',
				target: 'form'
			},
			{
				name: 'formstyle',
				target: 'field'
			},
			{
				name: 'margin',
				target: 'outer',
				title: 'Form Margin'
			},
			{
				name: 'formgdpr',
				target: 'gdpr'
			},
			{
				name: 'formbutton',
				target: 'submit'
			},
			{
				name: 'buttonicon',
				target: 'icon',
				title: 'Button Icon'
			},
			{
				name: 'border',
				target: 'submit',
				title: 'Button Border'
			},
			{
				name: 'corner',
				target: 'submit',
				title: 'Button Corner'
			},
			{
				name: 'facebook',
				target: 'fbopt'
			},
			{
				name: 'effect',
				target: 'outer'
			}

		]
	},
	{
		title: 'Countdown',
		type: 'countdown',
		icon: 'fas fa-tachometer-alt',
		classes: '',
		positioning: true,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'countdown',
				target: 'outer'
			},
			{
				name: 'countdownstyle',
				target: 'outer'
			},
			{
				name: 'countdowntexts',
				target: 'outer'
			},
			{
				name: 'expiryaction',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		],
		buttons: [
			{
				pos: 'first',
				id: 'countdown-normal', 
				icon: 'fas fa-arrow-left', 
				title: 'Show Countdown', 
				action: 'countdownnormal',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'countdown-normal',
				id: 'countdown-hidden', 
				icon: 'fas fa-arrow-right', 
				title: 'Show Hidden Content', 
				action: 'countdownhidden',
				classes: ''
			}
		],
	},
	{
		title: 'Comment',
		type: 'comment',
		icon: 'fas fa-comment',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'comment',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Share',
		type: 'share',
		icon: 'fas fa-share-alt',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'social',
				target: 'middle',
			},
			{
				name: 'socialurl',
				target: 'outer',
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Icon',
		type: 'icon',
		icon: 'fas fa-star',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		floatButtons: [
			{
				pos: 'first',
				id: 'toggle-align-left',
				icon: 'dashicons dashicons-align-left', 
				title: 'Move to Left', 
				action: 'alignposleft',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-left',
				id: 'toggle-align-center', 
				icon: 'dashicons dashicons-align-center', 
				title: 'Move to Center', 
				action: 'alignposcenter',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'toggle-align-center',
				id: 'toggle-align-right', 
				icon: 'dashicons dashicons-align-right', 
				title: 'Move to Right', 
				action: 'alignposright',
				classes: ''
			},
		],
		options: [
			{
				name: 'icon',
				target: 'icon',
			},
			{
				name: 'iconstyle',
				target: 'middle',
			},
			{
				name: 'padding',
				target: 'middle'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'border',
				target: 'middle'
			},
			{
				name: 'boxshadow',
				target: 'middle'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Progress Bar',
		type: 'progress',
		icon: 'fas fa-battery-half',
		classes: '',
		positioning: false,
		resizable: ['e'],
		category: 'element',
		options: [
			{
				name: 'progress',
				target: 'progress'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'HTML',
		type: 'code',
		icon: 'fas fa-code',
		classes: '',
		positioning: false,
		resizable: ['e'],
		targetWidth: ["middle"],
		category: 'element',
		options: [
			{
				name: 'html',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Shortcode',
		type: 'shortcode',
		icon: '',
		textIcon: '[ ]',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'shortcode',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: '3 Step Opt-In',
		type: 'optin3',
		icon: 'fa fa-envelope-square',
		classes: '',
		positioning: false,
		resizable: false,
		sortable: true,
		category: 'element',
		options: [
			{
				name: 'padding',
				target: 'optinslide'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		],
		buttons: [
			{
				pos: 'first',
				id: 'prev-slide', 
				icon: 'fas fa-arrow-left', 
				title: 'Previous Step', 
				action: 'prevslide',
				classes: '',
				actionclass: 'el-fbtn-action',
			},
			{
				pos: 'after',
				posid: 'prev-slide',
				id: 'next-slide', 
				icon: 'fas fa-arrow-right', 
				title: 'Next Step', 
				action: 'nextslide',
				classes: '',
				actionclass: 'el-fbtn-action',
			}
		],
	},
	{
		title: 'Navigation',
		type: 'menu',
		icon: 'fa fa-th-list',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'menutype',
				target: 'outer'
			},
			{
				name: 'menustyle',
				target: 'nav'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Map',
		type: 'map',
		icon: 'fas fa-map-marked-alt',
		classes: '',
		positioning: false,
		resizable: ["s", "e"],
		targetWidth: ["iframe"],
		targetHeight: ["iframe"],
		resizeParent: true,
		category: 'element',
		options: [
			{
				name: 'map',
				target: 'iframe'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Tabs',
		type: 'tabs',
		icon: 'glyphicon glyphicon-folder-close',
		classes: '',
		positioning: false,
		resizable: false,
		sortable: true,
		category: 'element',
		options: [
			{
				name: 'tabs',
				target: 'navtabs'
			},
			{
				name: 'tabstyle',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'tabpane'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		],
		buttons: [
			{
				pos: 'first',
				id: 'prev-slide', 
				icon: 'fas fa-plus', 
				title: 'Add Tab', 
				action: 'addtab',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'prev-slide',
				id: 'next-slide', 
				icon: 'fas fa-minus', 
				title: 'Remove Last Tab', 
				action: 'removetab',
				classes: ''
			}
		],
	},
	{
		title: 'Carousel',
		type: 'slides',
		icon: 'fas fa-images',
		classes: '',
		positioning: false,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'slides',
				target: 'middle'
			},
			{
				name: 'margin',
				target: 'outer'
			},
		],
		buttons: [
			{
				pos: 'first',
				id: 'prev-image', 
				icon: 'fas fa-plus', 
				title: 'Add Slide', 
				action: 'addimg',
				classes: ''
			},
			{
				pos: 'after',
				posid: 'prev-image',
				id: 'next-image', 
				icon: 'fas fa-minus', 
				title: 'Remove Last Slide', 
				action: 'removeimg',
				classes: ''
			}
		],
	},
	{
		title: 'Today\'s Date',
		type: 'date',
		icon: 'fa fa-calendar-o',
		classes: '',
		positioning: true,
		resizable: false,
		category: 'element',
		options: [
			{
				name: 'dateformat',
				target: 'outer'
			},
			{
				name: 'datestyle',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
		],
	},
	{
		title: 'Collapse',
		type: 'collapse',
		icon: 'far fa-minus-square',
		classes: '',
		positioning: false,
		resizable: false,
		sortable: true,
		category: 'element',
		options: [
			{
				name: 'collapse',
				target: 'collapsehead'
			},
			{
				name: 'padding',
				target: 'collapsecontent',
				title: 'Content Padding'
			},
			{
				name: 'margin',
				target: 'outer'
			},
			{
				name: 'effect',
				target: 'outer'
			}
		]
	},
	{
		title: 'Questions',
		type: 'questions',
		icon: 'fas fa-poll-h',
		classes: '',
		positioning: false,
		resizable: false,
		sortable: true,
		category: 'element',
		options: [
			{
				name: 'questions',
				target: 'outer'
			},
			{
				name: 'padding',
				target: 'outer'
			},
			{
				name: 'margin',
				target: 'outer'
			},
		],
		buttons: [
			{
				pos: 'first',
				id: 'prev-question', 
				icon: 'fas fa-arrow-left', 
				title: 'Previous', 
				action: 'prevquestion',
				classes: '',
				actionclass: "el-fbtn-action",
			},
			{
				pos: 'after',
				posid: 'prev-question',
				id: 'next-question', 
				icon: 'fas fa-arrow-right', 
				title: 'Next',
				action: 'nextquestion',
				classes: '',
				actionclass: "el-fbtn-action",
			}
		],
	}
];