PrimeBuilder.Html = {
	toolbar: 
				'<div class="prime-toolbar">\
					<div class="brand-wrapper">\
						<div class="brand-inner">\
							<div class="brand-item editor-exit"><a href="#" class="quit-btn"><i class="fas fa-arrow-left"></i></a></div>\
							<div class="brand-item editor-logo"><img src="{imgdir}ib-logo-big-updated.png" /></div>\
						</div>\
					</div>\
					<div class="btn-group clearfix" role="group" aria-label="Prime Toolbar">\
						<button type="button" id="undo-btn" title="Undo" class="btn btn-toolbar disabled">\
							<i class="fa fa-rotate-left"></i>\
						</button>\
						<button type="button" id="redo-btn" title="Redo" class="btn btn-toolbar disabled">\
							<i class="fa fa-rotate-right"></i>\
						</button>\
						<a href="#" role="button" title="View Page" target="_blank" class="btn main-editor-btn btn-toolbar view-page-btn">\
							<i class="fa fa-eye"></i>\
						</a>\
						<button type="button" title="Permalink" class="btn btn-toolbar main-editor-btn el-btn-action" data-action="permalink">\
							<i class="fas fa-link"></i>\
						</button>\
						<button type="button" title="Change Template" class="btn btn-toolbar main-editor-btn el-btn-action" data-action="template">\
							<i class="fas fa-broom"></i>\
						</button>\
						<button type="button" title="Settings" class="btn btn-toolbar main-editor-btn page-settings-btn">\
							<i class="fa fa-cog"></i>\
						</button>\
						<button type="button" title="Save" class="btn btn-toolbar main-editor-btn save-page-settings">\
							<i class="fa fa-save"></i>\
						</button>\
					</div>\
					<button type="button" title="Publish" class="btn btn-sm btn-success publish-page" style="margin-left: 10px">\
						<i class="fas fa-upload"></i> Publish\
					</button>\
					<span class="save-text hidden">Saving ...</span>\
				</div>',

	devices: 
				'<div class="prime-devices">\
					<ul>\
						<li><a href="#" class="el-btn-action" data-action="switcheditor" data-mode="mobile" title="Mobile Editor Mode"><i class="fas fa-mobile-alt"></i></a></li>\
						<li><a href="#" class="el-btn-action" data-action="switcheditor" data-mode="tablet"><i class="fas fa-tablet-alt" title="Tabvar Editor Mode"></i></a></li>\
						<li><a href="#" class="el-btn-action active-edit-mode" data-action="switcheditor" data-mode="desktop" title="Desktop Editor Mode"><i class="fas fa-desktop"></i></a></li>\
					</ul>\
				</div>',

	footer: 	
				'<div class="editor-footer"></div>',

	basePopup: 
				'<div id="{id}" class="settings-popup">\
					{header}\
					<div class="settings-popup-content"></div>\
					{footer}\
				</div>',

	popupHeader: 
				'<div class="settings-popup-header">\
					<button type="button" class="close close-setting-popup" aria-label="Close"><span aria-hidden="true">&times;</span></button>\
					<h4>{title}</h4>\
				</div>',

	popupFooter:
				'<div class="settings-popup-footer">\
					<div class="text-right setting-popup-buttons">\
						<button class="close-popup btn btn-default close-setting-popup" type="button">Close</button>\
					</div>\
				</div>',

	fieldForm: 
				'<div class="row settings-form-edit hidden">\
					<input type="hidden" class="field-index" value="" />\
					<div class="col-md-12">\
						<div class="form-group">\
	    					<label for="form-field-type">Field Type</label>\
	    					<select class="form-control field-type" id="form-field-type">\
	    						<option value="email">Email</option>\
	    						<option value="text">Text</option>\
	    						<option value="textarea">Textarea</option>\
	    						<option value="select">Dropdown Options</option>\
	    						<option value="radio">Radio Options</option>\
	    						<option value="checkbox">Checkbox</option>\
	    						<option value="hidden">Hidden</option>\
	    					</select>\
	  					</div>\
						<div class="form-group">\
	    					<label for="form-field-key">Field Name/Key</label>\
	    					<input type="text" class="form-control field-key" id="form-field-key" placeholder="e.g. email">\
	  					</div>\
	  					<div class="form-group">\
	    					<label for="form-field-label">Field Label</label>\
	    					<input type="text" class="form-control field-label" id="form-field-label" placeholder="e.g. Your Business Email">\
	  					</div>\
	  					<div class="form-group field-options-prop hidden">\
	    					<label for="form-field-options">Options</label>\
	    					<textarea class="form-control field-options" rows="3" id="form-field-options" placeholder="e.g. \'Option Text\' or \'optionvalue:Option Text\'"></textarea>\
	    					<p class="help-block" style="font-size: 12px">One option per line. Example: <code>Option Text</code> or <code>optionvalue:Option Text</code></p>\
	  					</div>\
	  					<div class="form-group">\
	    					<label for="form-field-value">Default Value</label>\
	    					<input type="text" class="form-control field-value" id="form-field-value">\
	    					<p class="help-block" style="font-size: 12px">For Advanced Users: To set a dynamic default value from a query string you can write in this format: <code>[[varkey]]</code>. Replace "varkey" with the actual key of the query string.</p>\
	  					</div>\
	  					<div class="form-group">\
	    					<label for="form-field-type">Icon</label>\
	    					<select class="form-control field-icon" id="form-field-icon">\
	    						<option value="none">None</option>\
	    						<option value="mail">Mail</option>\
	    						<option value="user">User</option>\
	    						<option value="home">Home</option>\
	    						<option value="phone">Phone</option>\
	    						<option value="mobile">Mobile Phone</option>\
	    						<option value="search">Search</option>\
	    						<option value="clock">Clock</option>\
	    					</select>\
	    					<p class="help-block" style="font-size: 12px">This setting only applies to <code>text</code> and <code>email</code> fields.</p>\
	  					</div>\
	  					<div class="checkbox">\
	    					<label>\
	    						<input type="checkbox" value="yes" class="field-required"> Required\
	    					</label>\
	  					</div>\
	  					<div class="checkbox non-hidden-fields">\
	    					<label>\
	    						<input type="checkbox" value="yes" class="field-hide"> Hide Field\
	    					</label>\
	  					</div>\
	  					<div class="checkbox hidden checked-by-default">\
	    					<label>\
	    						<input type="checkbox" value="yes" class="field-default"> Checked By Default\
	    					</label>\
	  					</div>\
	  					<div class="error-msg"></div>\
	  				</div>\
				</div>',

	highlight:
				'<div class="el-highlight">\
					<div class="el-name"></div>\
					<div class="adder-top element-adder">\
						<div class="adder-btn el-btn-action" title="Move Element Up" data-action="moveup"><i class="fas fa-arrow-up"></i></div>\
						<div class="adder-btn el-btn-action section-adder" title="Add New Section" data-action="addsection"><i class="far fa-square"></i></div>\
						<div class="adder-btn el-btn-action" title="Add New Element" data-action="addelement"><i class="fa fa-plus"></i></div>\
					</div>\
					<div class="adder-bottom element-adder">\
						<div class="adder-btn el-btn-action section-adder" title="Add New Section" data-action="addsection"><i class="far fa-square"></i></div>\
						<div class="adder-btn el-btn-action" title="Add New Element" data-action="addelement"><i class="fa fa-plus"></i></div>\
						<div class="adder-btn el-btn-action" title="Move Element Down" data-action="movedown"><i class="fas fa-arrow-down"></i></div>\
					</div>\
					<div class="el-fbuttons">\
						<div class="btn-group" role="group" aria-label="Element Style"></div>\
					</div>\
				</div>',

	selected:
				'<div class="el-selected">\
					<div class="el-buttons">\
						<div class="btn-group" role="group" aria-label="Element Options"></div>\
					</div>\
					<div class="el-resize-handlers"></div>\
				</div>',

	resizer:
				'<div class="el-n-resize el-resizer" data-resize="n"></div>\
				 <div class="el-s-resize el-resizer" data-resize="s"></div>\
				 <div class="el-w-resize el-resizer" data-resize="w"></div>\
				 <div class="el-e-resize el-resizer" data-resize="e"></div>\
				 <div class="el-se-resize el-resizer" data-resize="se"></div>',
	colResizer: 
				'<div id="{id}" class="el-col-resizer" data-col1="{id1}" data-col2="{id2}" data-pos="1">\
					<div class="col-resizer" title="Resize Column"></div>\
					<div class="col1-size-info hidden col-size-info">300.2px</div>\
					<div class="col2-size-info hidden col-size-info">152px</div>\
				</div>',

	settingsWrapper:
				'<div id="editor-settings" class="clearfix">\
					<button type="button" class="close close-settings-bar" style="margin-right: 10px" aria-label="Close"><span aria-hidden="true">&times;</span></button>\
					<ul class="global-settings-tab">\
						<li><a href="#" data-tab="active-settings" class="global-tab-link tab-settings-main tab-settings-active">Settings</a></li>\
						<li class="main-editor-btn hidden"><a href="#" data-tab="layers-settings" class="global-tab-link tab-settings-layers">Layers</a></li>\
						<li class="main-editor-btn"><a href="#" data-tab="split-settings"class="global-tab-link tab-settings-split">Variants</a></li>\
					</ul>\
				</div>',
	settings:
				'<div class="layers-settings main-editor-prop hidden">\
					<div class="global-fields">Layer Settings</div>\
				</div>\
				<div class="split-settings main-editor-prop hidden">\
					<div class="global-fields variant-table"></div>\
				</div>\
				<div class="active-settings">\
				</div>',
	
	settingTitle: '<h4 class="settings-title"><i class=""></i>&nbsp;<span></span></h4>',
	settingTabs: '<div class="settings-tabs" id="[[id]]"></div>',
	settingFields: '<div class="settings-fields" id="[[id]]"></div>',
	settingHeader: 
				'<div id="[[id]]" class="settings-header" data-type="image" data-for="margin">\
					<span class="settings-toggle"></span>&nbsp;\
					<div class="settings-mode btn-group hidden" role="group">\
						<button type="button" class="btn btn-xs mode-btn mode-all btn-success active" data-mode="all"><i class="far fa-window-minimize"></i></button>\
  						<button type="button" class="btn btn-xs mode-btn mode-single btn-default" data-mode="single"><i class="fas fa-stream"></i></button>\
					</div>\
					<div class="settings-arrow settings-toggle">\
						<i class="fa fa-angle-down"></i>\
					</div>\
				</div>',

	elementsWrapper: 
				'<div id="elements-bar">\
					<div class="scroll-els" data-toggle="tooltip" data-placement="right" title="Click to scroll">\
						<a href="#" class="scroll-elements" data-dir="up">\
							<i class="fas fa-caret-up"></i>\
						</a>\
					</div>\
					<div class="elements-icons"></div>\
					<div class="scroll-els" data-toggle="tooltip" data-placement="right" title="Click to scroll">\
						<a href="#" class="scroll-elements" data-dir="down">\
							<i class="fas fa-caret-down"></i>\
						</a>\
					</div>\
				</div>',

	fixedSection: 
				'<div id="{id}" class="ib2-section-el ib2-element" style="{outerstyle}" data-el="section">\
					<div class="el-content el-cols is-element" style="{midstyle}">\
						{content}\
					</div>\
				</div>',

	fluidSection: 
				'<div id="{id}" class="ib2-wsection-el ib2-section-el ib2-element" style="{outerstyle}" data-el="wsection">\
					<div class="el-content is-element" style="{midstyle}">\
						<div class="el-content-inner" style="{innerstyle}">\
							<div class="el-cols">\
								{content}\
							</div>\
						</div>\
					</div>\
				</div>',

	elementsMenu: 
				'<ul class="nav nav-pills change-element-type">\
					<li class="active"><a href="#" class="ib2-element-type" data-type="basic">Basic</a></li>\
					<li><a href="#" class="ib2-element-type hidden" data-type="combo">Combo</a></li>\
					<li><a href="#" class="ib2-element-type" data-type="saved">Saved Elements</a></li>\
				</ul>',

	normalCountdown: 
				'<span class="ib2-digit"><span id="{id}-tdays">0</span><span class="ib2-digit-txt"> day </span></span>\
				<span class="ib2-digit"><span id="{id}-thours">0</span><span class="ib2-digit-txt"> hour </span></span>\
				<span class="ib2-digit"><span id="{id}-tminutes">0</span><span class="ib2-digit-txt"> minute </span></span>\
				<span class="ib2-digit"><span id="{id}-tseconds">0</span><span class="ib2-digit-txt"> second </span></span>',

	circularCountdown: 
				'<div class="clock row">\
					<div class="clock-item clock-days col-sm-6 col-md-3">\
						<svg viewBox="0 0 120 120" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMinYMin meet">\
							<circle cx="60" cy="60" r="54" stroke-width="12" stroke="#e6e6e6" fill="none"></circle>\
  							<circle cx="60" cy="60" r="54" stroke-width="12" class="clock-anim" stroke="#E16464" fill="none" />\
						</svg>\
						<span class="ib2-digit"><span id="{id}-tdays">0</span><span class="ib2-digit-txt"> day </span></span>\
					</div>\
					<div class="clock-item clock-hours col-sm-6 col-md-3">\
						<svg viewBox="0 0 120 120" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMinYMin meet">\
							<circle cx="60" cy="60" r="54" stroke-width="12" stroke="#e6e6e6" fill="none"></circle>\
  							<circle cx="60" cy="60" r="54" stroke-width="12" class="clock-anim" stroke="#7995D5" fill="none" />\
						</svg>\
						<span class="ib2-digit"><span id="{id}-thours">0</span><span class="ib2-digit-txt"> hour </span></span>\
					</div>\
					<div class="clock-item clock-minutes col-sm-6 col-md-3">\
						<svg viewBox="0 0 120 120" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMinYMin meet">\
							<circle cx="60" cy="60" r="54" stroke-width="12" stroke="#e6e6e6" fill="none"></circle>\
  							<circle cx="60" cy="60" r="54" stroke-width="12" class="clock-anim" stroke="#6fdb6f" fill="none" />\
						</svg>\
						<span class="ib2-digit"><span id="{id}-tminutes">0</span><span class="ib2-digit-txt"> minute </span></span>\
					</div>\
					<div class="clock-item clock-seconds col-sm-6 col-md-3">\
						<svg viewBox="0 0 120 120" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMinYMin meet">\
							<circle cx="60" cy="60" r="54" stroke-width="12" stroke="#e6e6e6" fill="none"></circle>\
  							<circle cx="60" cy="60" r="54" stroke-width="12" class="clock-anim" stroke="#E7B708" fill="none" />\
						</svg>\
						<span class="ib2-digit"><span id="{id}-tseconds">0</span><span class="ib2-digit-txt"> second </span></span>\
					</div>\
				</div>',

	gdpr: 
		'<div class="form-group">\
			<div class="checkbox">\
				<label>\
					<input type="checkbox" class="eu-checkbox-field" value="1">\
					<span class="eu-text" style="color: #313131">Yes, I agree to receive transactional and marketing emails from YOUR BUSINESS.</span>\
				</label>\
			</div>\
		</div>',

	triangle:
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-triangle ib2-main-shape ib2-shape" points="886,0 800,96 714,0 0,0 0,100 1600,100 1600,0"></polygon>\
		</svg>',

	"small-triangle":
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-small-triangle ib2-main-shape ib2-shape" points="830,60 800,96 770,60 0,60 0,100 1600,100 1600,60"></polygon>\
		</svg>',

	"big-triangle": 
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-big-triangle ib2-main-shape ib2-shape" points="0,0 800,96 1600,0 1600,100 0,100 "></polygon>\
		</svg>',

	"triangle-asym": 
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-triangle-asym ib2-main-shape ib2-shape" points="0,10 450,95 1600,0 1600,100 0,100 "></polygon>\
		</svg>',

	slanted:
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-slanted ib2-main-shape ib2-shape" points="0,0 0,100 1600,100"></polygon>\
		</svg>',

	"slanted-opac":
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" viewBox="0 0 1600 100" width="100%" preserveAspectRatio="none">\
			<polygon class="ib2-slanted-opac ib2-main-shape ib2-shape" points="0,30 0,100 1600,100"></polygon>\
			<polygon class="ib2-dark-shade ib2-shape" points="0,0 0,30 1600,100"></polygon>\
			<polygon class="ib2-dark-fill ib2-shape" points="0,15 0,30 1600,100"></polygon>\
		</svg>',

	curve:
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" width="100%" viewBox="0 0 1600 100" preserveAspectRatio="none">\
    		<path class="ib2-curve ib2-main-shape ib2-shape" d="M0,20 C100,96 1600,96 1600,20 V100 H0 Z"></path>\
		</svg>',

	wavy:
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" width="100%" viewBox="0 0 1600 100" preserveAspectRatio="none">\
    		<path class="ib2-wavy ib2-main-shape ib2-shape" d="M0,90 C300,20 520,20 750,50 S1320,100 1600,30 V100 H0 Z"></path>\
		</svg>',

	waves: 
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" width="100%" viewBox="0 0 1600 100" preserveAspectRatio="none">\
			<path class="ib2-waves ib2-main-shape ib2-shape" d="M-40,95.627C20.307,95.627,20.058,56,80,56s60.003,40,120,40s59.948-40,120-40s60.313,40,120,40s60.258-40,120-40s60.202,40,120,40s60.147-40,120-40s60.513,40,120,40s60.036-40,120-40c59.964,0,60.402,40,120,40s59.925-40,120-40s60.291,40,120,40s60.235-40,120-40s60.18,40,120,40s59.82,0,59.82,0l0.18,138H-60V96L-40,95.627z"></path>\
		</svg>',

	"waves-opac": 
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" width="100%" viewBox="0 0 1600 100" preserveAspectRatio="none">\
			<path class="ib2-dark-shade ib2-shape" d="M-40,71.627C20.307,71.627,20.058,32,80,32s60.003,40,120,40s59.948-40,120-40s60.313,40,120,40s60.258-40,120-40s60.202,40,120,40s60.147-40,120-40s60.513,40,120,40s60.036-40,120-40c59.964,0,60.402,40,120,40s59.925-40,120-40s60.291,40,120,40s60.235-40,120-40s60.18,40,120,40s59.82,0,59.82,0l0.18,26H-60V72L-40,71.627z"></path>\
			<path class="ib2-dark-fill ib2-shape" d="M-40,83.627C20.307,83.627,20.058,44,80,44s60.003,40,120,40s59.948-40,120-40s60.313,40,120,40s60.258-40,120-40s60.202,40,120,40s60.147-40,120-40s60.513,40,120,40s60.036-40,120-40c59.964,0,60.402,40,120,40s59.925-40,120-40s60.291,40,120,40s60.235-40,120-40s60.18,40,120,40s59.82,0,59.82,0l0.18,14H-60V84L-40,83.627z"></path>\
			<path class="ib2-waves-opac ib2-main-shape ib2-shape" d="M-40,95.627C20.307,95.627,20.058,56,80,56s60.003,40,120,40s59.948-40,120-40s60.313,40,120,40s60.258-40,120-40s60.202,40,120,40s60.147-40,120-40s60.513,40,120,40s60.036-40,120-40c59.964,0,60.402,40,120,40s59.925-40,120-40s60.291,40,120,40s60.235-40,120-40s60.18,40,120,40s59.82,0,59.82,0l0.18,138H-60V96L-40,95.627z"></path>\
		</svg>',

	spikes:
		'<svg xmlns="http://www.w3.org/2000/svg" version="1.1" class="ib2-separator {posclass}" width="100%" viewBox="0 0 1600 100" preserveAspectRatio="none">\
			<polygon class="ib2-spikes ib2-main-shape ib2-shape" points="-40,63.667 19.833,3.833 80,64 140,4 200,64 260,4 320,64 380,4 440,64 500,4 560,64 620,4 680,64 740,4 800,64 860,4 920,64 980,4 1040,64 1100,4 1160,64 1220,4 1280.333,64.333 1340.333,4.333 1400,64 1460,4 1520,64 1578,6 1636,64 1636,104 -40,104 "></polygon>\
		</svg>',

	getInfobarHtml: function() {
		var infobar = '<div class="ib2-notification-bar">';
				infobar += '<div class="ib2-notification-text">';
					infobar += '<span class="att-text"></span> <a class="att-url" href="#" target="_blank"></a>';
				infobar += '</div>';
			infobar += '</div>';
		return infobar;
	},

	variantSettings: function(variantData) {
		var current = $('#ib2-current-variation').val(),
			html =
			'<table class="table">\
    			<thead>\
    				<tr><th>Variant</th><th>Weight</th><th>Action</th></tr>\
    			</thead>\
    			<tbody>';

    	var conversionType = ib2globalsettings['settings']['conversion_type'] || 'wp',
    		conversionId = ib2globalsettings['settings']['conversion_id'] || $('#ib2-post-id').val(),
    		selected, currentVar = $('#ib2-current-variation').val();
    	if ( typeof variantData !== "undefined" ) {
    		variantData.forEach(function(variant){
    			var variantTitle = ( variant.variant == currentVar ) ? '<strong>' + variant.title + '</strong>' : '<span class="text-muted">' + variant.title + '</span>';
    			html += '<tr>';
    				html += '<td>' + variantTitle + '</td>';
    				html += '<td><input type="number" class="form-control setting-input variant-weights" value="' + variant.weight + '" data-variant="' + variant.variant + '" style="width: 50px; display: inline"> %</td>';
    				html += '<td>';

    				if ( variant.variant != current ) {
    					html += '<a href="' + $('#ib2-editor-url').val() + '&variant=' + variant.variant + '" role="button" class="btn btn-xs btn-default" title="Edit ' + variant.title + '"><i class="fa fa-pencil"></i></a>&nbsp;';
    				}
    				if ( variant.variant != 'a' ) {
    					html += '<a href="#" role="button" class="btn btn-xs btn-danger el-btn-action" data-action="deletevariant" data-variant="' + variant.variant + '" title="Delete ' + variant.title + '"><i class="fa fa-trash-o"></i></a>';
    				}
    				html += '</td>';
    			html += '</tr>';
    		});
    	}
		html += '</tbody>';
		html += '</table>';
		html += '<div class="text-right"><button type="button" class="btn btn-xs btn-success btn-add-variant el-btn-action" data-action="template" data-type="variant"><i class="fa fa-plus"></i> New Variant</button></div>';
		html += '<hr>';
		html +=
			'<div class="form-group">\
    			<label for="conversion-type">Conversion Page Location</label>\
    			<select class="form-control" id="conversion-type">';

    	var options = {
    		wp: 'WordPress Post/Page',
    		external: 'External Page'
    	},
    	wpHidden = ( conversionType == 'external' ? ' hidden' : '' ),
    	codeHidden = ( conversionType == 'external' ? '' : ' hidden' );

		for ( var val in options ) {
			selected = ( conversionType == val ? ' selected="selected"' : '' );
			html += '<option value="' + val + '"' + selected + '>' + options[val] + '</option>';
		}
		html += '</select>';
		html += '</div>';
		html +=
			'<div class="form-group conversion-wp' + wpHidden + '">\
    			<label for="conversion-page">Conversion Page</label>\
    			<select class="form-control" id="conversion-page">\
    			<option value="0">-- select a post/page --</option>';
    			
    		for ( var group in ib2posts ) {
					html += '<optgroup label="' + group + '">';

					var posts = ib2posts[group];
					for ( var key in posts ) {
						selected = ( conversionId == key ? ' selected="selected"' : '' );
						var optiontxt = posts[key];
						html += '<option value="' + key + '"' + selected + '>' + optiontxt + '</option>';
					}

					html += '</optgroup>';
				}
		html += '</select>';
		html += '';
		html += '</div>';

		var jscode = this.conversionJS(conversionId);

		html +=
			'<div class="form-group conversion-ext' + codeHidden + '">\
    			<label for="conversion-type">Conversion Tracking Code</label>\
    			<textarea class="form-control" id="conversion-code" rows="5" readonly onclick="this.select();" onfocus="this.select();">';
    	html += jscode;
		html += '</textarea>';
		html += '</div>';

		return html;
	},

	conversionJS: function(conversion_id) {
		var conversionJS = '<script type="text/javascript">\n';
			conversionJS += '(function() {\n';
			conversionJS += 'var ib2scr = document.createElement(\'script\');\n';
			conversionJS += 'ib2scr.type = \'text/javascript\';\n';
			conversionJS += 'ib2scr.async = true;\n';
			conversionJS += 'ib2scr.src = \'' + $('#ib2-site-url').val() + '?ib2script=conversion_js&post_id=' + conversion_id + '\';\n';
			conversionJS += 'document.getElementsByTagName(\'head\')[0].appendChild(ib2scr);\n';
			conversionJS += '})();\n';
			conversionJS += '</script>';

		return conversionJS;
	},

	fieldOptions: function(options) {
		var defaults = {
			type: 'text',
			label: 'Field',
			defaultValue: '',
			placeholder: '',
			classes: '',
			styles: null,
			rows: 3,
			options: null,
			firstOption: null,
			min: 1,
			max: 10,
			step: 1,
			useMode: false,
			useTabs: false,
			mode: '',
			defaultMode: '',
			defaultTab: '',
			mediaType: 'image',
			mediaMultiple: false
		};

		return Object.assign({}, defaults, options);
	},

	formatStyle: function(styles) {
		var style = '';
		if ( typeof styles === 'object' ) {
			style += ' style="';
			for ( var key in styles ) {
				style += key + ': ' + styles[key] + '; ';
			}
			style += '"';
		} else if ( typeof styles === 'string' && styles != '' ) {
			style += ' style="' + styles + '"';
		}

		return style;
	},

	getField: function(type, fieldType, options) {
		var field;
		switch (fieldType) {
			case 'textarea':
				field = this.textarea(type, options);
				break;

			case 'select':
				field = this.selectField(type, options);
				break;

			case 'esp':
				field = this.espField(type, options);
				break;

			case 'list':
				field = this.espListField(type, options);
				break;

			case 'upload':
				field = this.uploadField(type, options);
				break;

			case 'color':
				field = this.colorField(type, options);
				break;

			case 'slider':
				field = this.sliderField(type, options);
				break;

			case 'border':
				field = this.borderField(type, options);
				break;

			case 'bgpos':
				field = this.bgposField(type, options);
				break;

			case 'checkbox':
				field = this.checkboxField(type, options);
				break;

			case 'timezone':
				field = this.tzField(type, options);
				break;

			case 'posts':
				field = this.pagesField(type, options);
				break;

			case 'fonts':
				field = this.fontsField(type, options);
				break;

			case 'fontstyle':
				field = this.fontstyleField(type, options);
				break;

			case 'desc':
				field = this.descField(type, options);
				break;

			case 'htmlform':
				field = this.htmlform(type, options);
				break;

			case 'date':
				field = this.dateField(type, options);
				break;

			case 'dynamic':
				field = this.dynamicField(type, options);
				break;

			case 'gateway':
				field = this.gatewayField(type, options);
				break;

			case 'sliderpop':
				field = this.slidepopField(type, options);
				break;

			case 'savetemplate':
				field = this.savetemplateField(type, options);
				break;

			case 'icon':
				field = this.iconField(type, options);
				break;

			case 'input':
			default:
				field = this.inputField(type, options);
				break;
		}
		return field;
	},

	dynamicField: function(type, options) {
		var html = '',
			newOptions = options,
			id = options['id'];

		if ( options.hasOwnProperty('dynamic') ) {
			options.dynamic.forEach(function(dynamic, i){
				for ( var key in dynamic ) {
					newOptions[key] = dynamic[key];
				}
				newOptions['id'] = id + '-' + dynamic['dynamic'] + '-{n}';
				newOptions['classes'] = type + '-fields';
				var output = this.getField(type, dynamic['type'], newOptions);
				html += output;
			}, this);
		}
		return html;
	},

	descField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '">\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	inputField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<input type="' + options.type + '" class="form-control setting-input" id="' + fieldId + '" data-el="' + type + '" placeholder="' + options.placeholder + '" value="' + options.defaultValue + '"' + style + '>\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	gatewayField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<input type="text" class="form-control" id="' + fieldId + '" data-el="' + type + '" placeholder="' + options.placeholder + '"' + style + ' readonly>\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	textarea: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<textarea class="form-control setting-input" id="' + fieldId + '" rows="' + options.rows + '" placeholder="' + options.placeholder + '"' + style + '>\
	    				' + options.defaultValue + '\
	    			</textarea>\
	    			' + desc + '\
	  			</div>';
	  	return html;
	},

	htmlform: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<textarea class="form-control setting-input" id="' + fieldId + '" rows="' + options.rows + '" placeholder="' + options.placeholder + '"' + style + '>\
	    				' + options.defaultValue + '\
	    			</textarea>\
	    			<div class="browse-btn text-right">\
	  					<button type="button" class="btn btn-xs btn-primary parse-form-btn" data-id="' + fieldId + '">Parse HTML</button>\
	  				</div>\
	    			' + desc + '\
	  			</div>';
	  	return html;
	},

	selectField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" || options.options === null || options.options === false ) {
			return '';
		}

		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input' + ( fieldId.indexOf('popup-edit') > -1 ? ' select-popup' : '' ) + '" id="' + fieldId + '"' + style + ' data-reveal="' + reveal + '">';


		var selected;
		if ( options.firstOption ) {
			selected = options.defaultValue == '' || options.defaultValue == 'none' ? ' selected="selected"' : '';
			html += '<option value="none"' + selected + '>' + options.firstOption + '</option>';
		}

		if ( typeof options.options === 'object' ) {
			for ( var val in options.options ) {
				selected = val == options.defaultValue ? ' selected="selected"' : '';
				html += '<option value="' + val + '"' + selected + '>' + options.options[val] + '</option>';
			}
		}
		html += '</select>';
		html += desc;

		if ( fieldId.indexOf('popup-edit') > -1 ) {
			html +=
					'<div class="popup-btns">\
						<button type="button" class="btn btn-xs btn-default edit-popup hidden el-btn-action" data-action="editpopup" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Edit Pop Up</button>\
	  					<button type="button" class="btn btn-xs btn-primary new-popup el-btn-action" data-action="editpopup" data-mode="new" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">New Pop Up</button>\
	  				</div>';
		}
		html += '</div>';
  		return html;
	},

	espField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" || options.options === null || options.options === false ) {
			return '';
		}

		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input" id="' + fieldId + '"' + style + ' data-reveal="' + reveal + '">';


		var selected;
		if ( options.firstOption ) {
			selected = options.defaultValue == '' || options.defaultValue == 'none' ? ' selected="selected"' : '';
			html += '<option value="none"' + selected + '>' + options.firstOption + '</option>';
		}

		if ( typeof options.options === 'object' ) {
			if ( !ib2esp.hasOwnProperty('mp') ) {
				delete options.options['mp'];
			}

			for ( var val in options.options ) {
				selected = val == options.defaultValue ? ' selected="selected"' : '';
				html += '<option value="' + val + '"' + selected + '>' + options.options[val] + '</option>';
			}
		}
		html += '</select>';
		html += desc;

		html +=
				'<div class="popup-btns esp-connect-btn hidden">\
					<p class="help-block">The service provider you selected hasn\'t been connected to InstaBuilder. Click the "Connect" button below to integrate.</p>\
					<button type="button"id="esp-connect-button" class="btn btn-xs btn-primary el-fbtn-action" data-action="apiconnect" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Connect</button>\
  				</div>';
		html += '</div>';
  		return html;
	},

	espListField: function(type, options) {
		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input' + ( fieldId.indexOf('popup-edit') > -1 ? ' select-popup' : '' ) + '" id="' + fieldId + '"' + style + ' data-reveal="' + reveal + '">';


		var selected;
		html += '<option value="none"> -- service not connected -- </option>';

		html += '</select>';
		html += desc;

		html +=
				'<div class="popup-btns esp-refresh-btn hidden">\
					<button type="button" class="btn btn-xs btn-primary el-fbtn-action" data-action="refreshlist" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '" data-loading-text="Fetching data...">Reload Data</button>\
  				</div>';
		html += '</div>';
  		return html;
	},

	slidepopField: function(type, options) {
		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html = '<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">';
    			
		html +=
				'<div class="popup-btns">\
					<button type="button" class="btn btn-xs btn-default edit-popup el-btn-action" data-action="editpopup" data-mode="slider" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Edit Slider</button>\
  				</div>';
		html += '</div>';
  		return html;
	},

	savetemplateField: function(type, options) {
		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html = '<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">';
    			
		html +=
				'<div class="popup-btns">\
					<p><button type="button" class="btn btn-xs btn-success el-btn-action" data-action="savetemplate" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Save as Template</button></p>\
					<p><button type="button" class="btn btn-xs btn-warning el-btn-action" data-action="restorehistory" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Restore Previous History</button></p>\
					<p><a href="' + $('#ib2-admin-url').val() + '?page=ib2-dashboard&ib2action=export_file&post_id=' + $('#ib2-post-id').val() + '" class="btn btn-xs btn-primary" target="_blank">Export</a></p>\
  				</div>';
		html += '</div>';
  		return html;
	},

	iconField: function(type, options) {
		var hidden = ( (options.useMode && options.mode != options.defaultMode) || 
						(options.useTabs && options.mode != options.defaultTab) ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('groupReveal') ? options.groupReveal : 'none' ),
			html = '<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">';
    		html += '<label for="' + fieldId + '">' + options.label + '</label>';
    		html += '<div class="icon-preview" style="font-size: 3em"><i class="' + options.defaultValue + '"></i></div>';
    		html += '<input type="hidden" class="form-control setting-input" id="' + fieldId + '" data-el="' + type + '" value="' + options.defaultValue + '">';
		html +=
				'<div class="popup-btns">\
					<p>\
						<button type="button" class="btn btn-xs btn-success el-fbtn-action" data-action="addicon" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Choose Icon</button>';

				if ( options.hasOwnProperty('removeIcon') && options.removeIcon ) {
					html += '&nbsp;<button type="button" class="btn btn-xs btn-danger btn-remove-icon el-fbtn-action" data-action="removeicon" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Remove Icon</button>';
				}
		html +=
				'	</p>\
  				</div>';
		html += '</div>';
  		return html;
	},

	checkboxField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			reveal = ( options.hasOwnProperty('reveal') ? options.reveal : 'none' ),
			negative = ( options['negative'] ? "yes" : 'no' ),
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<div class="checkbox">\
	    				<input type="checkbox" class="setting-input" id="' + fieldId + '" value="yes" data-reveal="' + reveal + '" data-negative="' + negative + '">\
	    				<label for="' + fieldId + '">' + options.label + '</label>\
	    			</div>\
	    			' + desc + '\
	  			</div>';
	  	return html;
	},

	dateField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<input type="date" class="form-control setting-input" id="' + fieldId + '" data-el="' + type + '" placeholder="' + options.placeholder + '" value="' + options.defaultValue + '"' + style + '>\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	fontsField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" || options.options === null || options.options === false ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input" id="' + fieldId + '"' + style + '>';

    		var selected;
			if ( typeof options.options === 'object' ) {
				for ( var group in options.options ) {
					html += '<optgroup label="' + group + ' Fonts">';

					var fonts = options.options[group];
					for ( var key in fonts ) {
						var fontValue = fonts[key].replace("'", '"');
						fontValue = fonts[key].replace(", ", ",");
						selected = fontValue == options.defaultValue ? ' selected="selected"' : '';
						html += '<option value="' + fontValue + '"' + selected + '>' + key + '</option>';
					}

					html += '</optgroup>';
				}
			}
			html += '</select>';
			html += desc;
  			html += '</div>';

  		return html;
	},

	fontstyleField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label><br />\
	    			<div class="btn-group">\
						<label class="btn btn-default button-bold-btn">\
	    					<input type="checkbox" class="setting-input font-style-input" id="' + fieldId + '-bold" data-prop="fontWeight" value="700" data-none="normal" style="display:none"><i class="fa fa-bold"></i>\
	  					</label>\
						<label class="btn btn-default button-bold-btn">\
	    					<input type="checkbox" class="setting-input font-style-input" id="' + fieldId + '-italic" data-prop="fontStyle" value="italic" data-none="normal" style="display:none"><i class="fa fa-italic"></i>\
	  					</label>\
	  					<label class="btn btn-default button-bold-btn">\
	    					<input type="checkbox" class="setting-input font-style-input" id="' + fieldId + '-underline" data-prop="textDecorationLine" value="underline" data-none="none" style="display:none"><i class="fa fa-underline"></i>\
	  					</label>\
					</div>\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	tzField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" || options.options === null || options.options === false ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input" id="' + fieldId + '"' + style + '>';

    		var selected;
			if ( typeof options.options === 'object' ) {
				for ( var group in options.options ) {
					html += '<optgroup label="' + group + '">';

					var tz = options.options[group];
					for ( var key in tz ) {
						var optiontxt = tz[key];
						selected = ( key == options.defaultValue ? ' selected="selected"' : '' );
						html += '<option value="' + key + '"' + selected + '>' + optiontxt + '</option>';
					}

					html += '</optgroup>';
				}
			}
			html += '</select>';
			html += desc;
  			html += '</div>';

  		return html;
	},

	pagesField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" || options.options === null || options.options === false ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			multiple = options.hasOwnProperty('multiple') && options.multiple ? ' multiple' : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>\
    			<select class="form-control setting-input"' + multiple + ' id="' + fieldId + '"' + style + '>';

    		var selected;
    		if ( options.firstOption ) {
				selected = options.defaultValue == '' || options.defaultValue == 'none' ? ' selected="selected"' : '';
				html += '<option value="none"' + selected + '>' + options.firstOption + '</option>';
			}
			if ( typeof options.options === 'object' ) {
				for ( var group in options.options ) {
					html += '<optgroup label="' + group + '">';

					var posts = options.options[group];
					for ( var key in posts ) {
						var optiontxt = posts[key];
						selected = ( key == options.defaultValue ? ' selected="selected"' : '' );
						html += '<option value="' + key + '"' + selected + '>' + optiontxt + '</option>';
					}

					html += '</optgroup>';
				}
			}
			html += '</select>';
			html += desc;
  			html += '</div>';

  		return html;
	},

	uploadField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<input type="' + options.type + '" class="form-control setting-input upload-url-val" id="' + fieldId + '" placeholder="' + options.placeholder + '" value="' + options.defaultValue + '"' + style + '>\
	  				<div class="browse-btn">\
	  					<button type="button" class="btn btn-xs btn-primary wp-media-btn" data-id="' + fieldId + '" data-media="' + options.mediaType + '" data-multiple="' + options.mediaMultiple + '" data-for="' + options.for + '" data-idx="' + options.idx + '" title="Upload"><i class="fas fa-upload"></i></button>\
	  					<button type="button" class="btn btn-xs btn-primary el-fbtn-action" data-action="ib2media" data-id="' + fieldId + '" title="Browse/Search" data-for="' + options.for + '" data-idx="' + options.idx + '"><i class="fas fa-folder-open"></i></button>\
	  					<button type="button" class="btn btn-xs btn-danger remove-media hidden" data-id="' + fieldId + '" data-for="' + options.for + '" data-idx="' + options.idx + '">Remove</button>\
	  				</div>\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	bgposField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<div class="image-preview hidden">\
	    				<img src="#" class="img-responsive">\
	    				<div id="' + fieldId + '-pos-ball" class="pos-ball"></div>\
	    			</div>\
	    			<input type="hidden" class="form-control setting-input bg-pos-value" id="' + fieldId + '" value="' + options.defaultValue + '">\
	    			' + desc + '\
	  			</div>';
	  	return html;
	},

	colorField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<input type="text" class="form-control setting-input color-picker" id="' + fieldId + '" placeholder="' + options.placeholder + '" value="' + options.defaultValue + '">\
	  				' + desc + '\
	  			</div>';
	  	return html;
	},

	sliderField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			fieldId = options.type + '-' + options.id + '-' + type,
			style = this.formatStyle(options.styles),
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html = 
				'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
	    			<label for="' + fieldId + '">' + options.label + '</label>\
	    			<div class="fields-group">\
	    				<div class="field-flex">\
	    					<input type="range" class="range-slider setting-input" id="' + fieldId + '" value="' + options.defaultValue + '"' + style + ' min="' + options.min + '" max="' + options.max + '" step="' + options.step + '">\
	    				</div>\
	    				<div class="field-narrow" style="width: 60px">\
	    						<input type="number" class="form-control range-slider-num setting-input ' + options.classes + '" id="' + fieldId + '-num" value="' + options.defaultValue + '" style="width: 50px">\
	    					</div>\
	    				</div>\
	    			</div>\
	    			' + desc + '\
	  			</div>';

	  	return html;
	},

	borderField: function(type, options) {
		options = this.fieldOptions(options);
		if ( typeof options.id === "undefined" ) {
			return '';
		}

		var hidden = ( options.useMode && options.mode != options.defaultMode || 
						options.useTabs && options.mode != options.defaultTab ) ? ' hidden group-' + options.mode : ' group-' + options.mode,
			modeClass = ( options.useMode ) ? ' mode-' + options.mode : '',
			style = this.formatStyle(options.styles),
			fieldId = options.type + '-' + options.id + '-' + type,
			desc = ( options.hasOwnProperty('desc') && options.desc != '' ) ? '<p class="help-block">' + options.desc + '</p>' : '',
			html =
			'<div class="form-group' + hidden + modeClass + ' ' + options.classes + '" data-type="' + options.type + '" data-for="' + options.for + '" data-idx="' + options.idx + '">\
    			<label for="' + fieldId + '">' + options.label + '</label>';

	    		html += 
	    				'<div class="fields-group">\
		    				<div class="field-flex">\
		    					<input type="range" class="range-slider setting-input border-width" id="' + fieldId + '-width">\
		    				</div>\
		    				<div class="field-narrow" style="width: 60px">\
		    					<input type="number" class="form-control range-slider-num setting-input" id="' + fieldId + '-width-num" style="width: 50px">\
		    				</div>\
		    			</div>';

		    	html += '<div class="fields-group">';
		    		
    				html += '<div class="field-flex">';
    					html += '<input type="text" class="form-control setting-input color-picker border-color" id="' + fieldId + '-color" placeholder="' + options.placeholder + '">';
    				html += '</div>';

    				html += '<div class="field-flex">';
    					html += '<select class="form-control setting-input border-style" id="' + fieldId + '-style">';

			    		var selected,
			    			borderOpts = ['none', 'solid', 'dotted', 'dashed', 'double', 'groove', 'ridge', 'inset', 'outset'];
			    			borderOpts.forEach(function(opt){
			    				html += '<option value="' + opt + '">' + opt + '</option>';
			    			});
			    		html += '</select>';
			    	html += '</div>';
			    	
    			html += '</div>';
    			html += desc;
  			html += '</div>';

  		return html;
	},
				
};