<?php
function ib2_section_html() {
return <<<EOT
	<div id="{id}" class="ib2-section-el ib2-element" style="width: {pagewidth}px; max-width: 100%; margin-left: auto; margin-right: auto;" data-el="section">
		<div class="el-content el-cols is-element" style="background-color: #FFFFFF; padding: 20px;">
			<div id="{id}-box" class="ib2-section-content" style="min-height: 40px; width: {pagewidth}px;"></div>
		</div>
	</div>
EOT;
}

function ib2_wsection_html() {
return <<<EOT
	<div id="{id}" class="ib2-wsection-el ib2-section-el ib2-element" style="width: 100%; max-width: 100%; margin-left: auto; margin-right: auto;" data-el="wsection">
		<div class="el-content is-element" style="background-color: #FFFFFF; padding: 20px;">
			<div class="el-content-inner" style="width: {pagewidth}px; margin: 0px auto">
				<div class="el-cols" style="max-width:100%; width:100%;">
					<div id="{id}-box" class="ib2-section-content" style="margin: 0px auto; max-width:100%; min-height: 40px; width: {pagewidth}px;"></div>
				</div>
			</div>
		</div>
	</div>
EOT;
}

function ib2_columns_html() {
return <<<EOT
	<div id="{id}" class="ib2-section-el ib2-element" style="max-width: 100%; margin-left: auto; margin-right: auto;" data-el="columns">
		<div class="el-content el-cols is-element" style="background-color: transparent; max-width: 100%;">
			<div id="{id}-box" class="ib2-section-content ib2-section-col" style="margin: 0px auto; width: {colWidth}px; max-width:100%; min-height: 40px;"></div>
			<div id="{id}-box{n}" class="ib2-section-content ib2-section-col ib-last-col" style="margin: 0px auto; max-width:100%; min-height: 40px;"></div>
		</div>
	</div>
EOT;
}

function ib2_column_html() {
return <<<EOT
	<div id="{id}-box{n}" class="ib2-section-content ib2-section-col" style="margin: 0px auto; max-width:100%; min-height: 400px;"></div>
EOT;
}

function ib2_wbox_html() {
return <<<EOT
	<div id="{id}" style="top: {top}; left: 0px; height: 300px; width: 100%; margin-top: 0px; margin-bottom: 0px;" class="ib2-content-el ib2-wide-box ib2-element" data-el="wbox">
		<div class="el-content is-element" style="background-color: #D0E0E3; width: 100%; max-width: 100%; padding: 0px; opacity: 1">
			<div id="{id}-box" style="height: 300px; width: 100%;"></div>
		</div>
	</div>
EOT;
}

function ib2_image_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-image-el ib2-element" data-el="image" style="text-align:center">
		<div class="el-content is-element" style="display: inline-block; max-width: 100%; width: 560px; height: auto;">
			<figure>
				<picture>						
					<source srcset="{image}" media="(min-width: 600px)">						
					<img src="{image}" style="width: 560px; height: auto">
				</picture>
			</figure>
		</div>
	</div>
EOT;
}

function ib2_icon_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-icon-el ib2-element" data-el="icon" style="text-align:center">
		<div class="el-content is-element" style="display: inline-block; padding: 10px; max-width: 100%; color: #444; font-size: 3em">
			<i class="fas fa-star"></i>
		</div>
	</div>
EOT;
}

function ib2_box_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-box-el ib2-element" data-el="box" style="max-width: 100%; text-align: center; margin-top: 10px; margin-bottom: 20px;">
		<div class="el-content is-element" style="display: inline-block; width: 400px; max-width: 100%; height: auto; min-height: 200px; border-radius: 10px;">
			<div id="{id}-box" class="ib2-box-wrapper" style="width: 400px; min-height: 200px; height: auto; max-width: 100%; background-color: #FFFFFF; border: 1px solid #eaeaea; padding: 30px 25px; border-radius: 10px; box-shadow: none;">
					<div class="ib2-box-content ib2-section-content" style="min-height: 200px;">
					</div>
			</div>
		</div>
	</div>
EOT;
}

function ib2_title_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-text-el ib2-title-el ib2-element is-element" data-el="text">
		<h2>This Is Your New Title</h2>
	</div>
EOT;
}

function ib2_text_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text">
		<p>This is your new text content. You can modify this text, add more paragraph, change font style or add images by clicking the edit button.</p>
	</div>
EOT;
}

function ib2_video_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-video-container ib2-element" data-el="video" data-video-type="youtube" style="text-align: center; width: 640px; margin: 0px auto 24px; padding: 10px">
		<div class="el-content ib2-video-responsive-class is-element">
			<img src="{video}" class="img-responsive vid-placeholder">
		</div>
		<div class="clearfix"></div>
	</div>
EOT;
}

function ib2_button_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-button-el ib2-element" data-el="button" data-button-type="flat" data-target="url" style="text-align:center; max-width:100%">
		<div class="el-content is-element" style="display: inline-block; height: auto; width: 250px; min-height: 50px;">
			<a href="#" class="ib2-button" style="font-size: 24px; width: 250px; min-height: 50px; color: #FFFFFF; background-color: #428bca; border-color: #357ebd; border-radius: 5px; text-shadow: 1px 1px 0 #4a4a4a; background-image: none; letter-spacing: 1px; line-height: 50px; --button-hover-color:#ffffff; --button-hover-bg:#3071a9; --button-hover-tshadow:1px 1px 0px #4a4a4a">
				<span class="ib2-btn-txt">Click Here</span>
			</a>
		</div>
	</div>
EOT;
}

function ib2_form_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-form-el ib2-element" data-el="form" data-form-mode="vertical" style="text-align: center; margin-top: 10px; margin-bottom: 18px;">
		<div class="el-content is-element" style="width:400px; max-width:100%; display:inline-block;">
			<form role="form" class="row" method="post">
				<div class="form-fields col-sm-12 col-md-12">
					<div class="ib2-field-group form-group"><input type="text" name="optin-name" class="form-control ib2-opt-field ib2-required" placeholder="First Name"></div>
					<div class="ib2-field-group form-group"><input type="email" name="optin-email" class="form-control ib2-opt-field ib2-required ib2-validate-email" placeholder="Email Address"></div>
				</div>
				<div class="button-fields col-sm-12 col-md-12">
					<button type="submit" id="{id}-submit" class="ib2-button ib2-form-submit" data-button-type="flat" style="color: #FFFFFF; background-color: #e7bc21; border-color: #b7930e; font-size:18px; border-radius: 5px; text-shadow:1px 1px 0 #4e4e4e; --form-hover-color:#ffffff; --form-hover-bg:#f69b2c; --form-hover-tshadow:1px 1px 0px #4a4a4a"><span class="ib2-btn-txt">Submit</span></button>
					<input type="image" id="{id}-image" class="ib2-form-image" src="{imgbtn}" alt="Submit" style="display:none" />
				</div>
			</form>
			<div class="clearfix"></div>
			<div id="{id}-fb" class="ib2-facebook-optin" style="display:none">
				<p class="ib2-facebook-optin-txt">Have a Facebook account?</p>
				<button class="ib2-fb-button ib2-facebook-subscribe" type="button">Subscribe with Facebook</button>
			</div>
		</div>
	</div>
EOT;
}

function ib2_spacer_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-element" data-el="spacer" style="height: 100px;">
		<div class="el-content is-element" style="width: 100%; margin: 0px; padding: 0px; max-width: 100%; height: 100px;"></div>
	</div>
EOT;
}

function ib2_countdown_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-countdown-el ib2-element is-element" style="font-size:24px; text-align:center; color:#444; text-shadow: 1px 1px 0 #999;" data-el="countdown" data-style="text" data-mode="date" data-target="2020-08-17 00:00" data-tz="{offset}" data-end="none" data-url="" data-after="" data-before=""></div>
EOT;
}

function ib2_hline_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-hline-el ib2-element" data-el="hline" style="margin-top: 10px; margin-bottom: 18px">
		<div class="el-content is-element" style="width: 400px; margin: 0 auto; max-width: 100%">
			<div class="ib2-hline" style="width: 400px; max-width: 100%; height: 10px; border-top: 2px solid #a7a7a7"></div>
		</div>
	</div>
EOT;
}

function ib2_comment_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-comment-el ib2-element" data-el="comment" data-comment="facebook" style="margin-top: 10px; margin-bottom: 18px">
		<div class="el-content is-element element-placeholder" style="width:100%; max-width:100%; min-height: 30px; display:inline-block">
			<span class="area-hidden"><em>Comment Placeholder (selected system: <span class="comment-system content-preview">Facebook</span>)</em></span>
		</div>
	</div>
EOT;
}

function ib2_shortcode_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-shortcode-el is-element ib2-element element-placeholder" data-el="shortcode" style="margin-top: 10px; margin-bottom: 18px">
		<span class="area-hidden"><em>Shortcode Placeholder (current shortcode: <span class="current-shortcode content-preview"></span>)</em></span>
	</div>
EOT;
}

function ib2_code_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-code-el ib2-element" data-el="code" style="margin-top: 10px; margin-bottom: 18px">
		<div class="el-content is-element" style="max-width:100%; min-height: 20px; width: 100%; height: auto; display: inline-block;">
			<p>Edit this element to replace this text with your code.</p>
		</div>
	</div>
EOT;
}

function ib2_progress_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-progress-el ib2-element is-element" data-el="progress" style="margin-top: 10px; margin-bottom: 18px">
		<div class="progress">
  			<div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="background-color: #5cb85c; min-width: 2em; width: 50%;">50%</div>
		</div>
	</div>
EOT;
}

function ib2_share_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-share-el ib2-element " data-el="share" style="margin-top: 10px; margin-bottom: 18px" data-custom-url="">
		<div class="el-content is-element" style="max-width: 100%;">
			<div class="ib2-facebook-share ib2-share-btn"><a href="#"><i class="fab fa-facebook-f"></i></a></div>
			<div class="ib2-twitter-share ib2-share-btn"><a href="#"><i class="fab fa-twitter"></i></a></div>
			<div class="ib2-linkedin-share ib2-share-btn"><a href="#"><i class="fab fa-linkedin-in"></i></a></div>
			<div class="ib2-google-share ib2-share-btn"><a href="#"><i class="fab fa-google-plus-g"></i></a></div>
			<div class="clearfix"></div>
		</div>
	</div>
EOT;
}

function ib2_menu_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-menu-el ib2-element is-element" data-el="menu" data-style="plain" data-menu="none">
		<button type="button" class="ib2-navbar-toggle">
			<span class="sr-only">Toggle navigation</span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
		</button>
		<nav class="clearfix">{menu}</nav>
	</div>
EOT;
}

function ib2_date_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-date-el ib2-element is-element" data-el="date" data-format="dddd, MMMM Do, YYYY" data-tz="{offset}" style="margin-bottom: 20px;">{today}</div>
EOT;
}

function ib2_collapse_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-collapse-el ib2-element is-element" data-el="collapse" style="margin-bottom: 20px;">
		<button class="ib2-collapse-head" title="Click to Open"><span class="ib2-collapse-title">Collapse Title</span></button>
		<div class="ib2-collapse-panel" style="max-height: 0px">
			<div class="ib2-section-content ib2-collapse-content">
				<div id="{id1}" class="ib2-content-el ib2-text-el ib2-element is-element" data-animation="none" data-shadow="none" data-el="text">
					<p>This is the content of your collapse box. This is a text element and you can drag n drop other elements into this area.</p>
				</div>
			</div>
		</div>
	</div>
EOT;
}

function ib2_map_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-map-el ib2-element" data-el="map" style="text-align: center; margin-bottom: 20px;">
		<div class="el-content is-element" style="display: inline-block; width: 100%; max-width: 100%;">
			<iframe frameborder="0" src="https://maps.google.com/maps?&z=1&t=q&output=embed" style="width: 100%; height: 100px; max-width: 100%"></iframe>
		</div>
	</div>
EOT;
}

function ib2_tabs_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-tabs-el ib2-element is-element" data-el="tabs" style="margin-bottom: 20px;">
		<ul id="{id}-tabs" class="ib2-nav-tabs" role="tablist">
			<li class="ib2-tabs-active"><a href="#{id}-0" role="tab"><span class="ib2-tab-title">Tab #1</span></a></li>
			<li><a href="#{id}-1" role="tab"><span class="ib2-tab-title">Tab #2</span></a></li>
			<li><a href="#{id}-2" role="tab"><span class="ib2-tab-title">Tab #3</span></a></li>
		</ul>
		<div class="ib2-tab-content">
			<div class="ib2-section-content ib2-tabs-active ib2-tab-pane" id="{id}-0">
				<div id="{id1}" class="ib2-content-el ib2-text-el ib2-element is-element" data-animation="none" data-shadow="none" data-el="text">
					<p>This is the content of the tab number 1. This is a text element and you can drag n drop other elements into this area.</p>
				</div>
			</div>
			<div class="ib2-section-content ib2-tab-pane" id="{id}-1">
				<div id="{id2}" class="ib2-content-el ib2-text-el ib2-element is-element ui-sortable-handle" data-animation="none" data-shadow="none" data-el="text">
					<p>This is the content of the tab number 2. This is a text element and you can drag n drop other elements into this area.</p>
				</div>
			</div>
			<div class="ib2-section-content ib2-tab-pane" id="{id}-2">
				<div id="{id3}" class="ib2-content-el ib2-text-el ib2-element is-element ui-sortable-handle" data-animation="none" data-shadow="none" data-el="text">
					<p>This is the content of the tab number 3. This is a text element and you can drag n drop other elements into this area.</p>
				</div>
			</div>
		</div>
	</div>
EOT;
}

function ib2_slides_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-slide-container ib2-element" data-el="slides" style="max-width: 100%; margin-bottom: 20px;">
		<div class="el-content is-element" style="max-width:100%">
			<div id="{id}-slides" class="carousel slide" data-ride="carousel">
				<ol class="carousel-indicators">
					<li data-target="#{id}-slides" data-slide-to="0" class="active"></li>
					<li data-target="#{id}-slides" data-slide-to="1"></li>
				</ol>
				<div class="carousel-inner" role="listbox">
					<div class="item active">
						<img src="{slide1}" alt="Slide 1">
						<div class="carousel-caption">Slide #1 Example</div>
					</div>
					<div class="item">
						<img src="{slide2}" alt="Slide 2">
						<div class="carousel-caption">Slide #2 Example</div>
					</div>
				</div>

				<a class="left carousel-control" href="#{id}-slides" role="button" data-slide="prev">
					<span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span>
					<span class="sr-only">Previous</span>
				</a>
				<a class="right carousel-control" href="#{id}-slides" role="button" data-slide="next">
					<span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
					<span class="sr-only">Next</span>
				</a>
			</div>
		</div>
		<div class="clearfix"></div>
	</div>
EOT;
}

function ib2_optin3_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-optslide-el ib2-element is-element" data-el="optin3" data-current-slide="1" style="margin-bottom: 20px;">
		<div id="{id}-1" class="ib2-section-content ib2-section-slide ib2-section-slide-1 ib2-slide-active" data-slide="1" style="display: block; padding: 20px;">
			<div id="{id1}" class="ib2-content-el ib2-text-el ib2-title-el ib2-element is-element" data-el="text">
				<h2 style="text-align:center">Discover How To Build<br>High Converting Landing Pages<br>In 5 Minutes...<br>No HTML Skill Required!</h2>
			</div>
			<div id="{id2}" class="ib2-content-el ib2-button-el ib2-element" data-el="button" data-target="url" style="text-align: center; max-width: 100%; margin-bottom: 14px;">
				<div class="el-content is-element" style="display: inline-block; width: 268px; height: auto; min-width: 0px; min-height: 42px;">
					<a href="#go-to-step-2" class="ib2-button" style="color: rgb(255, 255, 255); background-color: rgb(66, 139, 202); border-color: rgb(53, 126, 189); border-radius: 5px; text-shadow: rgb(74, 74, 74) 1px 1px 0px; background-image: none; font-size: 20px; line-height: 40px; min-width: 0px; width: 268px; --button-hover-color:#ffffff; --button-hover-bg:#3071a9; --button-hover-tshadow:1px 1px 0px #4a4a4a">
						<span class="ib2-btn-txt">Click Here To Find Out &raquo;</span>
					</a>
				</div>
			</div>
		</div>
		<div id="{id}-2" class="ib2-section-content ib2-section-slide ib2-section-slide-2" data-slide="2" style="display: none; padding: 20px;">
			<div id="{id3}" class="ib2-content-el ib2-video-container ib2-element" data-el="video" style="text-align: center; width: 640px; margin: 0px auto 24px;">
				<div class="el-content ib2-video-responsive-class is-element">
					<img src="{video}" class="img-responsive vid-placeholder">
				</div>
				<div class="clearfix"></div>
			</div>
			<div id="{id4}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text">
				<p style="text-align:right"><a href="#go-to-step-3"><strong>Next Video &raquo;</strong></a></p>
			</div>
		</div>
		<div id="{id}-3" class="ib2-section-content ib2-section-slide ib2-section-slide-3" data-slide="3" style="display: none; padding: 20px;">
			<div id="ib2_el_x0at2n7k" class="ib2-content-el ib2-text-el ib2-title-el ib2-element is-element" data-el="text">
				<h2 style="text-align:center">Please Register Below ... <br>And Get Access To The Complete Video Series!</h2>
			</div>
			<div id="{id5}" class="ib2-content-el ib2-element ib2-form-el" data-el="form" style="text-align: center; margin-bottom: 18px;">
				<div class="el-content is-element" style="width: 374px; max-width: 100%; display: inline-block;">
					<form role="form" method="post" class="row">
						<div class="form-fields col-sm-12 col-md-12">
							<div class="ib2-field-group form-group">
								<input type="email" name="optin-email" class="form-control ib2-opt-field ib2-required ib2-validate-email field-sharp input-lg" placeholder="Email Address" style="background-color: rgb(244, 244, 244);">
							</div>
						</div>
						<div class="button-fields col-sm-12 col-md-12">
							<button type="submit" id="{id5}-submit" class="ib2-button ib2-form-submit" data-button-type="flat" style="color: rgb(255, 255, 255); background-color: rgb(230, 148, 34); border-color: rgb(202, 120, 6); font-size: 24px; border-radius: 0px; text-shadow: rgb(78, 78, 78) 1px 1px 0px; background-image: none; letter-spacing: 1px; font-weight: bold; font-family: Roboto, sans-serif; --form-hover-color:#ffffff; --form-hover-bg:#f69b2c; --form-hover-tshadow:1px 1px 0px #4a4a4a">
								<span class="ib2-btn-txt">Send Me The Videos!</span>
							</button>

							<input type="image" id="{id5}-image" class="ib2-form-image" src="{imgbtn}" alt="Subscribe" style="display:none">
						</div>
					</form>
					<div class="clearfix"></div>
					<div id="{id5}-fb" class="ib2-facebook-optin" style="display:none">
						<p class="ib2-facebook-optin-txt">Have a Facebook account?</p>
						<button class="ib2-fb-button ib2-facebook-subscribe" type="button">Subscribe with Facebook</button>
					</div>
				</div>
			</div>
		</div>
EOT;
}

function ib2_popup_html() {
return <<<EOT
	<div id="{id}" class="ib2-section-el ib2-popup ib2-element" style="width: 700px; max-width: 100%; height: auto;" data-el="section">
		<div class="el-content el-cols is-element" style="background-color: #FFF; padding: 30px 40px;">
			<div id="{id}-box" class="ib2-pop-content ib2-section-content ui-sortable" style="width: 100%; min-height: 286px;">
				<div id="{id1}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text" style="padding: 0px; position: relative;">
					<p style="text-align: center;"><span style="color: rgb(153, 153, 153);">(Enter your email address below and click "Continue..." to complete)</span></p>
				</div>
				<div id="{id2}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text" style="padding: 0px; position: relative;">
					<p style="text-align: center;"><strong><span style="font-size: 24px;">Fill Out the Form Below To Get Your FREE Copy...</span></strong></p>
				</div>
				<div id="{id3}" class="ib2-content-el ib2-element" data-el="spacer" style="height: 14px;">
					<div class="el-content is-element" style="width: 100%; margin: 0px; padding: 0px; max-width: 100%; height: 14px;"></div>
				</div>
				<div id="{id4}" class="ib2-content-el ib2-element ib2-form-el" data-el="form" style="text-align: center; margin-bottom: 18px;">
					<div class="el-content is-element" style="width: 374px; max-width: 100%; display: inline-block;">
						<form role="form" method="post" class="row">
							<div class="form-fields col-sm-12 col-md-12">
								<div class="ib2-field-group form-group">
									<input type="email" name="optin-email" class="form-control ib2-opt-field ib2-required ib2-validate-email field-sharp input-lg" placeholder="Email Address" style="background-color: rgb(244, 244, 244);">
								</div>
							</div>
							<div class="button-fields col-sm-12 col-md-12">
								<button type="submit" id="{id4}-submit" class="ib2-button ib2-form-submit" style="color: rgb(255, 255, 255); background-color: rgb(230, 148, 34); border-color: rgb(202, 120, 6); font-size: 24px; border-radius: 0px; text-shadow: rgb(78, 78, 78) 1px 1px 0px; background-image: none; letter-spacing: 1px; font-weight: bold; font-family: Roboto, sans-serif; --form-hover-color:#ffffff; --form-hover-bg:#f69b2c; --form-hover-tshadow:1px 1px 0px #4a4a4a">
									<span class="ib2-btn-txt">Continue ...</span>
								</button>
								<input type="image" id="{id4}-image" class="ib2-form-image" src="{imgbtn}" alt="Subscribe" style="display:none">
							</div>
						</form>
						<div class="clearfix"></div>
						<div id="{id4}-fb" class="ib2-facebook-optin" style="display:none">
							<p class="ib2-facebook-optin-txt">Have a Facebook account?</p>
							<button class="ib2-fb-button ib2-facebook-subscribe" type="button">Subscribe with Facebook</button>
						</div>
					</div>
				</div>
				<div id="{id5}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text" style="padding: 0px; position: relative;">
					<p style="text-align: center;"><span style="font-size: 12px; color: rgb(184, 184, 184);">Your privacy is important to us and we will not spam you</span></p>
				</div>
				<div id="{id6}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text" style="padding: 0px; position: relative; left: 0px; top: 0px;">
					<p style="text-align: center;"><strong><span style="font-size: 13px;">By signing up you'll also receive access to daily {Company Name} tips and exclusive offers.</span></strong><br><strong><span style="font-size: 13px;">Please read&nbsp;the {Company Name} <a href="#">Privacy Policy</a>.</span></strong></p>
				</div>
			</div>
		</div>
		<a href="#" class="ib2-close-pop"><i class="fas fa-times"></i></a>
	</div>
EOT;
}

function ib2_questions_html() {
return <<<EOT
	<div id="{id}" class="ib2-content-el ib2-element is-element ib2-questions-el" data-el="questions" style="margin-bottom: 20px;" data-questions="1">
		<div id="{id}-1" class="ib2-quiz-page" style="display: block;" data-question="1">
			<h3 class="quiz-text-edit quiz-text-question" style="color:#333333">This is your number #1 question. Simply click this text to edit?</h3>
			<div id="{id}-1-answers" class="ib2-answer-list" style="color:#333333">
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 1 for the number 1 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 2 for the number 1 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 3 for the number 1 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 4 for the number 1 question</span></label>
					</div>
				</div>
			</div>
		</div>
		<div id="{id}-2" class="ib2-quiz-page ib2-unused-question" style="display: hidden;" data-question="2">
			<h3 class="quiz-text-edit quiz-text-question" style="color:#333333">This is your number #2 question. Simply click this text to edit?</h3>
			<div id="{id}-2-answers" class="ib2-answer-list" style="color:#333333">
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 1 for the number 2 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 2 for the number 2 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 3 for the number 2 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 4 for the number 2 question</span></label>
					</div>
				</div>
			</div>
		</div>
		<div id="{id}-3" class="ib2-quiz-page ib2-unused-question" style="display: hidden;" data-question="3">
			<h3 class="quiz-text-edit quiz-text-question" style="color:#333333">This is your number #3 question. Simply click this text to edit?</h3>
			<div id="{id}-3-answers" class="ib2-answer-list" style="color:#333333">
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 1 for the number 3 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 2 for the number 3 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 3 for the number 3 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 4 for the number 3 question</span></label>
					</div>
				</div>
			</div>
		</div>
		<div id="{id}-4" class="ib2-quiz-page ib2-unused-question" style="display: hidden;" data-question="4">
			<h3 class="quiz-text-edit quiz-text-question" style="color:#333333">This is your number #4 question. Simply click this text to edit?</h3>
			<div id="{id}-4-answers" class="ib2-answer-list" style="color:#333333">
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 1 for the number 4 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 2 for the number 4 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 3 for the number 4 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 4 for the number 4 question</span></label>
					</div>
				</div>
			</div>
		</div>
		<div id="{id}-5" class="ib2-quiz-page ib2-unused-question" style="display: hidden;" data-question="5">
			<h3 class="quiz-text-edit quiz-text-question" style="color:#333333">This is your number #5 question. Simply click this text to edit?</h3>
			<div id="{id}-5-answers" class="ib2-answer-list" style="color:#333333">
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 1 for the number 5 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a> 
						<label><span class="quiz-text-edit">Answer number 2 for the number 5 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 3 for the number 5 question</span></label>
					</div>
				</div>
				<div class="form-group has-pretty-child">
					<div class="clearfix prettyradio labelright margin-right blue">
						<a class="" href="#"></a>
						<label><span class="quiz-text-edit">Answer number 4 for the number 5 question</span></label>
					</div>
				</div>
			</div>
		</div>
		
		<div id="{id}-result" style="display: none; min-height: 98px;" class="ib2-quiz-page ib2-section-content">
			<div id="{id1}" class="ib2-content-el ib2-text-el ib2-title-el ib2-element is-element ui-sortable-handle" data-el="text">
				<h3>Your Survey Result</h3>
			</div>
			<div id="{id2}" class="ib2-content-el ib2-text-el ib2-element is-element" data-el="text">
				<p>You can place the content for the quiz result here. Feel free to put any element, such as opt-In, video, button, etc.</p>
			</div>
		</div>
	</div>
EOT;
}

function ib2_elements_html() {
	return array(
		'section' => ib2_section_html(),
		'wsection' => ib2_wsection_html(),
		'columns' => ib2_columns_html(),
		'wbox' => ib2_wbox_html(),
		'image' => ib2_image_html(),
		'box' => ib2_box_html(),
		'title' => ib2_title_html(),
		'text' => ib2_text_html(),
		'video' => ib2_video_html(),
		'button' => ib2_button_html(),
		'spacer' => ib2_spacer_html(),
		'column' => ib2_column_html(),
		'form' => ib2_form_html(),
		'countdown' => ib2_countdown_html(),
		'hline' => ib2_hline_html(),
		'comment' => ib2_comment_html(),
		'icon' => ib2_icon_html(),
		'shortcode' => ib2_shortcode_html(),
		'code' => ib2_code_html(),
		'map' => ib2_map_html(),
		'progress' => ib2_progress_html(),
		'share' => ib2_share_html(),
		'menu' => ib2_menu_html(),
		'date' => ib2_date_html(),
		'collapse' => ib2_collapse_html(),
		'tabs' => ib2_tabs_html(),
		'slides' => ib2_slides_html(),
		'optin3' => ib2_optin3_html(),
		'questions' => ib2_questions_html(),
		'popup' => ib2_popup_html(),
	);
}